---
title: XRViewerPose.views
slug: Web/API/XRViewerPose/views
tags:
  - 3D
  - API
  - AR
  - Property
  - Read-only
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR Device API
  - XR
  - XRViewerPose
  - augmented
  - pose
  - views
---
<p>{{APIRef("WebXR Device API")}}{{secureContext_header}}</p>

<p>The read-only {{domxref("XRViewerPose")}} property <strong><code>views</code></strong> returns an array which contains every {{domxref("XRView")}} which must be rendered in order to fully represent the scene from the viewpoint defined by the viewer pose. For monoscopic devices, this array contains a single view.</p>

<div class="notecard warning">
<p><strong>Important:</strong> There is no guarantee that the number of views will remain constant over the lifetime of an {{domxref("XRSession")}}. For each frame, you should always use the current length of this array rather than caching the value.</p>
</div>

<p>Stereo views require two views to render properly, with the left eye's view having its {{domxref("XRView.eye", "eye")}} set to the string <code>left</code> and the right eye's view a value of <code>right</code>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>viewList</em> = <em>xrViewerPose</em>.views;</pre>

<h3 id="Value">Value</h3>

<p>An array of {{domxref("XRView")}} objects, one for each view available as part of the scene for the current viewer pose. This array's length may potentially vary over the lifetime of the {{domxref("XRSession")}} (for example, if the viewer enables or disables stereo mode on their XR output device).</p>

<h2 id="Examples">Examples</h2>

<p>In this example—part of the code to render an {{domxref("XRFrame")}}, <code>getViewerPose()</code> is called to get an <code>XRViewerPose</code> using the same reference space the code is using as its base reference space. If a valid pose is returned, the frame is rendered by clearing the backbuffer and then rendering each of the views in the pose; these are most likely the views for the left and right eyes.</p>

<pre class="brush: js">let pose = frame.getViewerPose(xrReferenceSpace);

if (pose) {
  let glLayer = xrSession.renderState.baseLayer;

  gl.bindFrameBuffer(gl.FRAMEBUFFER, glLayer.framebuffer);
  gl.clearColor(0, 0, 0, 1);
  gl.clearDepth(1);
  gl.clear(gl.COLOR_BUFFER_BIT, gl.DEPTH_BUFFER_BIT);

  for (let view of pose.views) {
    let viewport = glLayer.getViewport(view);
    gl.viewport(viewport.x, viewport.y, viewport.width, viewport.height);

    /* render the scene for the eye view.eye */
  }
}
</pre>

<p>Passing each <code>view</code> to {{domxref("XRWebGLLayer.getViewport", "getViewport()")}} returns the WebGL viewport to apply in order to cause the rendered output to be positioned correctly in the framebuffer for renderijng to the corresponding eye on the output device.</p>

<p>This code is derived from {{SectionOnPage("/en-US/docs/Web/API/WebXR_Device_API/Movement_and_motion", "Drawing a frame")}}. You can see more context and see much more on that page.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrviewerpose-views','XRViewerPose.views')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.XRViewerPose.views")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Movement_and_motion">Movement, orientation, and motion</a></li>
</ul>
